<!-- This View renders all houses using the houseList component, it also renders a searchbar which filters listing by their address!-->

<template>

  <div class="home">
    <h3>All Listings</h3>
    <input class="searchBar" type="text" v-model="searchText" placeholder="Filter by address" v-on:input="filter"/>
    <div/>
    <HouseList v-if="firstTime != null" v-bind:listings="searchedListing"/>
  </div>
</template>
<style scoped>
  .searchBar {
    width: 20vw;
    margin-left: 10vw;
    margin-bottom: 10px;

  }
  h3 {
    font-family: 'Quicksand';
    margin-left: 10vw;
  }
</style>

<script>
import HouseList from '../components/listing/HouseList'
import Data from '../global/variable.js' //Holding all data.
export default {
  name: 'Index',
  components: {
    HouseList
  },
  data() {
    return {
        listings: [],
        firstTime: null,
        searchedListing : [],
        searchText: '',
        searchType: 'address',
    }
  },
  /**
   * When the component is mounted we filter the listings in a way which is accepteable for the houselist component.
   * Namely we extract both the index of the list and the agent in charge of it so that we easily can access it.
   */
  mounted() {
    const agents = Data.agents
    const listings = []

    agents.forEach((agent, index) => {
      agent.listings.forEach((listing, lIndex) => {
        listings.push({agentId: index, id: lIndex, ...listing})
      })
    })
    this.listings = listings
    this.searchedListing = listings
    this.firstTime = true
  },
  methods: {
    /**
     * Filters by the searchText address
     */
    filter() {
      const searched = []
      if(this.searchText.trim() !== '') {
        this.listings.forEach(listing => {
          if(listing[this.searchType].toLowerCase().includes(this.searchText.toLowerCase())) {
                    searched.push(listing)
                  }
        })
        this.searchedListing = searched
      }
      else {
        this.searchedListing = this.listings
      }
      //This emits an update event which is picked up by the child components.
      setTimeout(() => {
        this.$emit('update');
      }, 1);
      
    }
  }

}
</script>
